/*
  swiches in intervalls between decoders
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include "switcher.h"


Switcher::Switcher(){
  timer = new QTimer();
  decoders = new PtrArray();
  current=0;
  QObject::connect( timer, SIGNAL(timeout()), this, SLOT(timeEvent()) );
  msec=0;
  metaPlayer=NULL;
}
 
Switcher::~Switcher() {
  int i;
  int n=decoders->getFillgrade();
  GenericStreamProducer* decoder;
  if (metaPlayer != NULL) {
    metaPlayer->setGenericStreamProducer(NULL);
  }

  for(i=0;i<n;i++) {
    decoder=(GenericStreamProducer*)decoders->getPtrAt(i);
    delete decoder;
  }

  delete decoders;
}


void Switcher::setMetaPlayer(MetaPlayer* metaPlayer) {
  this->metaPlayer=metaPlayer;
}


void Switcher::add(GenericStreamProducer* decoder) {
  decoders->add(decoder);
}

void Switcher::timeEvent() {
  GenericStreamProducer* nextDecoder;

  int next=current+1;
  if (decoders->getFillgrade() <= 0) {
    cout << "no size"<<endl;
    return;
  }
  if (metaPlayer == NULL) {
    cout << "no metaPlayer"<<endl;
    return;
  }

  if (next == decoders->getFillgrade()) {
    next=0;
  }


  cout << "netx decoder ######################decoder:"<<nextDecoder<<endl;


  nextDecoder=(GenericStreamProducer*)decoders->getPtrAt(next);

  metaPlayer->setGenericStreamProducer(NULL);
  metaPlayer->setGenericStreamProducer(nextDecoder);
  

  current=next;
}
  


void Switcher::start(int msec) {
  this->msec=msec;
  timer->start( msec );
}


